(function( global ) {
    // Get handles
    var loginButton = document.getElementById( 'loginButton' ),
        logoutButton = document.getElementById( 'logoutButton' ),
        subscribeButton = document.getElementById( 'subscribeButton' );

    // As its a demo, we'll do this
    var subs = [];

    var onLogin = function( res ) {
        console.log( 'Login Callback Fired' );
    };

    var onSubscribe = function( identifier, status, expiry ) {
        console.log( 'Subscribe Callback Fired' );

        document.querySelector( '#subscribeButton span' ).className = '';
        document.querySelector( '#subscribingIcon' ).className = 'hidden';
    };

    var onGetSubscriptions = function( res ) {
        if ( res.length ) {
            document.querySelector( '#subscribeButton span' ).innerHTML = '£' + res[0].price || '£399';
        }

        // Flat replace global subs
        subs = res;
    };

    var onLoginChange = function( res ) {
        console.log( 'login change' );
        console.log( res.userName ? 'logged in as ' + res.userName : 'currently logged out' );

        function updateUsername( username ) {
            elUserName.innerHTML = username;
        }

        function showLogin() {
            loginButton.className = '';
            logoutButton.className = 'hidden';
        }

        function hideLogin() {
            loginButton.className = 'hidden';
            logoutButton.className = '';
        }

        res.userName ? hideLogin() : showLogin();
    };


     var subscribe = function() {
        document.querySelector( '#subscribeButton span' ).className = 'hidden';
        document.querySelector( '#subscribingIcon' ).className = '';

        Banner.subscribe( subs[0].identifier, onSubscribe );
    };


    // Perform init stuff
    Banner.loginStateChanged( onLoginChange );
    Banner.getSubscriptions( onGetSubscriptions );

    // Expose
    global.BannerDemo = {
        subscribe: subscribe,
        onLogin: onLogin
    };

})( this );
